diff --git a/gcc/tree-ssa-forwprop.c b/gcc/tree-ssa-forwprop.c
index 563abe0..d990100 100644
--- a/gcc/tree-ssa-forwprop.c
+++ b/gcc/tree-ssa-forwprop.c
@@ -184,7 +184,7 @@ static bool forward_propagate_addr_expr (tree, tree, bool);
 /* Set to true if we delete dead edges during the optimization.  */
 static bool cfg_changed;
 
-static tree rhs_to_tree (tree type, gimple stmt);
+static tree rhs_to_tree (tree type, gimple *stmt);
 
 /* Get the next statement we can propagate NAME's value into skipping
    trivial copies.  Returns the statement that is suitable as a
@@ -192,11 +192,11 @@ static tree rhs_to_tree (tree type, gimple stmt);
    This only returns destinations in a single-use chain.  FINAL_NAME_P
    if non-NULL is written to the ssa name that represents the use.  */
 
-static gimple
+static gimple *
 get_prop_dest_stmt (tree name, tree *final_name_p)
 {
   use_operand_p use;
-  gimple use_stmt;
+  gimple *use_stmt;
 
   do {
     /* If name has multiple uses, bail out.  */
@@ -226,13 +226,13 @@ get_prop_dest_stmt (tree name, tree *final_name_p)
    it is set to whether the chain to NAME is a single use chain
    or not.  SINGLE_USE_P is not written to if SINGLE_USE_ONLY is set.  */
 
-static gimple
+static gimple *
 get_prop_source_stmt (tree name, bool single_use_only, bool *single_use_p)
 {
   bool single_use = true;
 
   do {
-    gimple def_stmt = SSA_NAME_DEF_STMT (name);
+    gimple *def_stmt = SSA_NAME_DEF_STMT (name);
 
     if (!has_single_use (name))
       {
@@ -262,7 +262,7 @@ get_prop_source_stmt (tree name, bool single_use_only, bool *single_use_p)
    propagation source.  Returns true if so, otherwise false.  */
 
 static bool
-can_propagate_from (gimple def_stmt)
+can_propagate_from (gimple *def_stmt)
 {
   gcc_assert (is_gimple_assign (def_stmt));
 
@@ -310,7 +310,7 @@ static bool
 remove_prop_source_from_use (tree name)
 {
   gimple_stmt_iterator gsi;
-  gimple stmt;
+  gimple *stmt;
   bool cfg_changed = false;
 
   do {
@@ -347,7 +347,7 @@ remove_prop_source_from_use (tree name)
    routines that deal with gimple exclusively . */
 
 static tree
-rhs_to_tree (tree type, gimple stmt)
+rhs_to_tree (tree type, gimple *stmt)
 {
   location_t loc = gimple_location (stmt);
   enum tree_code code = gimple_assign_rhs_code (stmt);
@@ -373,7 +373,7 @@ rhs_to_tree (tree type, gimple stmt)
    considered simplified.  */
 
 static tree
-combine_cond_expr_cond (gimple stmt, enum tree_code code, tree type,
+combine_cond_expr_cond (gimple *stmt, enum tree_code code, tree type,
 			tree op0, tree op1, bool invariant_only)
 {
   tree t;
@@ -411,7 +411,7 @@ combine_cond_expr_cond (gimple stmt, enum tree_code code, tree type,
    were no simplifying combines.  */
 
 static tree
-forward_propagate_into_comparison_1 (gimple stmt,
+forward_propagate_into_comparison_1 (gimple *stmt,
 				     enum tree_code code, tree type,
 				     tree op0, tree op1)
 {
@@ -423,7 +423,7 @@ forward_propagate_into_comparison_1 (gimple stmt,
      simplify comparisons against constants.  */
   if (TREE_CODE (op0) == SSA_NAME)
     {
-      gimple def_stmt = get_prop_source_stmt (op0, false, &single_use0_p);
+      gimple *def_stmt = get_prop_source_stmt (op0, false, &single_use0_p);
       if (def_stmt && can_propagate_from (def_stmt))
 	{
 	  rhs0 = rhs_to_tree (TREE_TYPE (op1), def_stmt);
@@ -437,7 +437,7 @@ forward_propagate_into_comparison_1 (gimple stmt,
   /* If that wasn't successful, try the second operand.  */
   if (TREE_CODE (op1) == SSA_NAME)
     {
-      gimple def_stmt = get_prop_source_stmt (op1, false, &single_use1_p);
+      gimple *def_stmt = get_prop_source_stmt (op1, false, &single_use1_p);
       if (def_stmt && can_propagate_from (def_stmt))
 	{
 	  rhs1 = rhs_to_tree (TREE_TYPE (op0), def_stmt);
@@ -466,7 +466,7 @@ forward_propagate_into_comparison_1 (gimple stmt,
 static int 
 forward_propagate_into_comparison (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree tmp;
   bool cfg_changed = false;
   tree type = TREE_TYPE (gimple_assign_lhs (stmt));
@@ -501,7 +501,7 @@ forward_propagate_into_comparison (gimple_stmt_iterator *gsi)
    This must be kept in sync with forward_propagate_into_cond.  */
 
 static int
-forward_propagate_into_gimple_cond (gimple stmt)
+forward_propagate_into_gimple_cond (gimple *stmt)
 {
   tree tmp;
   enum tree_code code = gimple_cond_code (stmt);
@@ -565,7 +565,7 @@ forward_propagate_into_gimple_cond (gimple stmt)
 static bool
 forward_propagate_into_cond (gimple_stmt_iterator *gsi_p)
 {
-  gimple stmt = gsi_stmt (*gsi_p);
+  gimple *stmt = gsi_stmt (*gsi_p);
   tree tmp = NULL_TREE;
   tree cond = gimple_assign_rhs1 (stmt);
   enum tree_code code = gimple_assign_rhs_code (stmt);
@@ -581,7 +581,7 @@ forward_propagate_into_cond (gimple_stmt_iterator *gsi_p)
     {
       enum tree_code def_code;
       tree name = cond;
-      gimple def_stmt = get_prop_source_stmt (name, true, NULL);
+      gimple *def_stmt = get_prop_source_stmt (name, true, NULL);
       if (!def_stmt || !can_propagate_from (def_stmt))
 	return 0;
 
@@ -647,7 +647,7 @@ forward_propagate_into_cond (gimple_stmt_iterator *gsi_p)
 static bool
 combine_cond_exprs (gimple_stmt_iterator *gsi_p)
 {
-  gimple stmt = gsi_stmt (*gsi_p);
+  gimple *stmt = gsi_stmt (*gsi_p);
   tree cond, val1, val2;
   bool changed = false;
 
@@ -655,7 +655,7 @@ combine_cond_exprs (gimple_stmt_iterator *gsi_p)
   val1 = gimple_assign_rhs2 (stmt);
   if (TREE_CODE (val1) == SSA_NAME)
     {
-      gimple def_stmt = SSA_NAME_DEF_STMT (val1);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (val1);
       if (is_gimple_assign (def_stmt)
 	  && gimple_assign_rhs_code (def_stmt) == gimple_assign_rhs_code (stmt)
 	  && operand_equal_p (gimple_assign_rhs1 (def_stmt), cond, 0))
@@ -668,7 +668,7 @@ combine_cond_exprs (gimple_stmt_iterator *gsi_p)
   val2 = gimple_assign_rhs3 (stmt);
   if (TREE_CODE (val2) == SSA_NAME)
     {
-      gimple def_stmt = SSA_NAME_DEF_STMT (val2);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (val2);
       if (is_gimple_assign (def_stmt)
 	  && gimple_assign_rhs_code (def_stmt) == gimple_assign_rhs_code (stmt)
 	  && operand_equal_p (gimple_assign_rhs1 (def_stmt), cond, 0))
@@ -695,7 +695,7 @@ combine_cond_exprs (gimple_stmt_iterator *gsi_p)
    relevant data structures to match.  */
 
 static void
-tidy_after_forward_propagate_addr (gimple stmt)
+tidy_after_forward_propagate_addr (gimple *stmt)
 {
   /* We may have turned a trapping insn into a non-trapping insn.  */
   if (maybe_clean_or_replace_eh_stmt (stmt, stmt)
@@ -722,7 +722,7 @@ forward_propagate_addr_expr_1 (tree name, tree def_rhs,
 			       bool single_use_p)
 {
   tree lhs, rhs, rhs2, array_ref;
-  gimple use_stmt = gsi_stmt (*use_stmt_gsi);
+  gimple *use_stmt = gsi_stmt (*use_stmt_gsi);
   enum tree_code rhs_code;
   bool res = true;
 
@@ -1034,7 +1034,7 @@ static bool
 forward_propagate_addr_expr (tree name, tree rhs, bool parent_single_use_p)
 {
   imm_use_iterator iter;
-  gimple use_stmt;
+  gimple *use_stmt;
   bool all = true;
   bool single_use_p = parent_single_use_p && has_single_use (name);
 
@@ -1093,9 +1093,9 @@ forward_propagate_addr_expr (tree name, tree rhs, bool parent_single_use_p)
 static bool
 forward_propagate_comparison (gimple_stmt_iterator *defgsi)
 {
-  gimple stmt = gsi_stmt (*defgsi);
+  gimple *stmt = gsi_stmt (*defgsi);
   tree name = gimple_assign_lhs (stmt);
-  gimple use_stmt;
+  gimple *use_stmt;
   tree tmp = NULL_TREE;
   gimple_stmt_iterator gsi;
   enum tree_code code;
@@ -1191,8 +1191,8 @@ bailout:
 static bool 
 simplify_conversion_from_bitmask (gimple_stmt_iterator *gsi_p)
 {
-  gimple stmt = gsi_stmt (*gsi_p);
-  gimple rhs_def_stmt = SSA_NAME_DEF_STMT (gimple_assign_rhs1 (stmt));
+  gimple *stmt = gsi_stmt (*gsi_p);
+  gimple *rhs_def_stmt = SSA_NAME_DEF_STMT (gimple_assign_rhs1 (stmt));
 
   /* See if the input for the conversion was set via a BIT_AND_EXPR and
      the only use of the BIT_AND_EXPR result is the conversion.  */
@@ -1256,9 +1256,9 @@ simplify_conversion_from_bitmask (gimple_stmt_iterator *gsi_p)
 static bool 
 simplify_not_neg_expr (gimple_stmt_iterator *gsi_p)
 {
-  gimple stmt = gsi_stmt (*gsi_p);
+  gimple *stmt = gsi_stmt (*gsi_p);
   tree rhs = gimple_assign_rhs1 (stmt);
-  gimple rhs_def_stmt = SSA_NAME_DEF_STMT (rhs);
+  gimple *rhs_def_stmt = SSA_NAME_DEF_STMT (rhs);
 
   /* See if the RHS_DEF_STMT has the same form as our statement.  */
   if (is_gimple_assign (rhs_def_stmt)
@@ -1284,7 +1284,7 @@ simplify_not_neg_expr (gimple_stmt_iterator *gsi_p)
    have values outside the range of the new type.  */
 
 static void
-simplify_gimple_switch_label_vec (gimple stmt, tree index_type)
+simplify_gimple_switch_label_vec (gimple *stmt, tree index_type)
 {
   unsigned int branch_num = gimple_switch_num_labels (stmt);
   auto_vec<tree> labels (branch_num);
@@ -1354,7 +1354,7 @@ simplify_gimple_switch_label_vec (gimple stmt, tree index_type)
    the condition which we may be able to optimize better.  */
 
 static bool
-simplify_gimple_switch (gimple stmt)
+simplify_gimple_switch (gimple *stmt)
 {
   /* The optimization that we really care about is removing unnecessary
      casts.  That will let us do much better in propagating the inferred
@@ -1362,7 +1362,7 @@ simplify_gimple_switch (gimple stmt)
   tree cond = gimple_switch_index (stmt);
   if (TREE_CODE (cond) == SSA_NAME)
     {
-      gimple def_stmt = SSA_NAME_DEF_STMT (cond);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (cond);
       if (gimple_assign_cast_p (def_stmt))
 	{
 	  tree def = gimple_assign_rhs1 (def_stmt);
@@ -1417,7 +1417,7 @@ constant_pointer_difference (tree p1, tree p2)
     {
       tree p = i ? p1 : p2;
       tree off = size_zero_node;
-      gimple stmt;
+      gimple *stmt;
       enum tree_code code;
 
       /* For each of p1 and p2 we need to iterate at least
@@ -1500,7 +1500,7 @@ constant_pointer_difference (tree p1, tree p2)
 static bool
 simplify_builtin_call (gimple_stmt_iterator *gsi_p, tree callee2)
 {
-  gimple stmt1, stmt2 = gsi_stmt (*gsi_p);
+  gimple *stmt1, *stmt2 = gsi_stmt (*gsi_p);
   tree vuse = gimple_vuse (stmt2);
   if (vuse == NULL)
     return false;
@@ -1522,7 +1522,7 @@ simplify_builtin_call (gimple_stmt_iterator *gsi_p, tree callee2)
 	  tree val2 = gimple_call_arg (stmt2, 1);
 	  tree len2 = gimple_call_arg (stmt2, 2);
 	  tree diff, vdef, new_str_cst;
-	  gimple use_stmt;
+	  gimple *use_stmt;
 	  unsigned int ptr1_align;
 	  unsigned HOST_WIDE_INT src_len;
 	  char *src_buf;
@@ -1703,7 +1703,7 @@ simplify_builtin_call (gimple_stmt_iterator *gsi_p, tree callee2)
 static bool
 truth_valued_ssa_name (tree name)
 {
-  gimple def;
+  gimple *def;
   tree type = TREE_TYPE (name);
 
   if (!INTEGRAL_TYPE_P (type))
@@ -1729,7 +1729,7 @@ lookup_logical_inverted_value (tree name)
 {
   tree op1, op2;
   enum tree_code code;
-  gimple def;
+  gimple *def;
 
   /* If name has none-intergal type, or isn't a SSA_NAME, then
      return.  */
@@ -1825,7 +1825,7 @@ simplify_bitwise_binary_1 (enum tree_code code, tree type,
 static inline void
 defcodefor_name (tree name, enum tree_code *code, tree *arg1, tree *arg2)
 {
-  gimple def;
+  gimple *def;
   enum tree_code code1;
   tree arg11;
   tree arg21;
@@ -1903,7 +1903,7 @@ simplify_bitwise_binary_boolean (gimple_stmt_iterator *gsi,
 				 enum tree_code code,
 				 tree op0, tree op1)
 {
-  gimple op0_def_stmt = SSA_NAME_DEF_STMT (op0);
+  gimple *op0_def_stmt = SSA_NAME_DEF_STMT (op0);
 
   if (!is_gimple_assign (op0_def_stmt)
       || (gimple_assign_rhs_code (op0_def_stmt) != BIT_NOT_EXPR))
@@ -1917,7 +1917,7 @@ simplify_bitwise_binary_boolean (gimple_stmt_iterator *gsi,
     {
       enum tree_code newcode;
 
-      gimple stmt = gsi_stmt (*gsi);
+      gimple *stmt = gsi_stmt (*gsi);
       gimple_assign_set_rhs1 (stmt, x);
       gimple_assign_set_rhs2 (stmt, op1);
       if (code == BIT_AND_EXPR)
@@ -1938,7 +1938,7 @@ simplify_bitwise_binary_boolean (gimple_stmt_iterator *gsi,
 static bool
 simplify_bitwise_binary (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree arg1 = gimple_assign_rhs1 (stmt);
   tree arg2 = gimple_assign_rhs2 (stmt);
   enum tree_code code = gimple_assign_rhs_code (stmt);
@@ -1957,7 +1957,7 @@ simplify_bitwise_binary (gimple_stmt_iterator *gsi)
       && INTEGRAL_TYPE_P (TREE_TYPE (def1_arg1))
       && int_fits_type_p (arg2, TREE_TYPE (def1_arg1)))
     {
-      gimple newop;
+      gimple *newop;
       tree tem = make_ssa_name (TREE_TYPE (def1_arg1), NULL);
       newop =
         gimple_build_assign_with_ops (code, tem, def1_arg1,
@@ -1980,7 +1980,7 @@ simplify_bitwise_binary (gimple_stmt_iterator *gsi)
       && types_compatible_p (TREE_TYPE (def1_arg1), TREE_TYPE (def2_arg1))
       && hoist_conversion_for_bitop_p (TREE_TYPE (arg1), TREE_TYPE (def1_arg1)))
     {
-      gimple newop;
+      gimple *newop;
       tree tem = make_ssa_name (TREE_TYPE (def1_arg1), NULL);
       newop = gimple_build_assign_with_ops (code, tem, def1_arg1, def2_arg1);
       gimple_set_location (newop, gimple_location (stmt));
@@ -2022,7 +2022,7 @@ simplify_bitwise_binary (gimple_stmt_iterator *gsi)
 	}
       else
 	{
-	  gimple newop;
+	  gimple *newop;
 	  tree tem;
 	  tem = make_ssa_name (TREE_TYPE (arg2), NULL);
 	  newop = gimple_build_assign_with_ops (code, tem, a, c);
@@ -2046,7 +2046,7 @@ simplify_bitwise_binary (gimple_stmt_iterator *gsi)
       tree cst = fold_build2 (BIT_AND_EXPR, TREE_TYPE (arg2),
 			      arg2, def1_arg2);
       tree tem;
-      gimple newop;
+      gimple *newop;
       if (integer_zerop (cst))
 	{
 	  gimple_assign_set_rhs1 (stmt, def1_arg1);
@@ -2200,7 +2200,7 @@ simplify_bitwise_binary (gimple_stmt_iterator *gsi)
 	      == TYPE_UNSIGNED (TREE_TYPE (arg2))))
 	{
 	  use_operand_p use_p;
-          gimple use_stmt;
+          gimple *use_stmt;
 
 	  if (single_imm_use (gimple_assign_lhs (stmt), &use_p, &use_stmt))
 	    {
@@ -2247,14 +2247,14 @@ simplify_bitwise_binary (gimple_stmt_iterator *gsi)
 static bool
 simplify_rotate (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree arg[2], rtype, rotcnt = NULL_TREE;
   tree def_arg1[2], def_arg2[2];
   enum tree_code def_code[2];
   tree lhs;
   int i;
   bool swapped_p = false;
-  gimple g;
+  gimple *g;
 
   arg[0] = gimple_assign_rhs1 (stmt);
   arg[1] = gimple_assign_rhs2 (stmt);
@@ -2464,7 +2464,7 @@ simplify_rotate (gimple_stmt_iterator *gsi)
 static bool
 associate_plusminus (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree rhs1 = gimple_assign_rhs1 (stmt);
   tree rhs2 = gimple_assign_rhs2 (stmt);
   enum tree_code code = gimple_assign_rhs_code (stmt);
@@ -2482,7 +2482,7 @@ associate_plusminus (gimple_stmt_iterator *gsi)
       /* A +- (-B) -> A -+ B.  */
       if (TREE_CODE (rhs2) == SSA_NAME)
 	{
-	  gimple def_stmt = SSA_NAME_DEF_STMT (rhs2);
+	  gimple *def_stmt = SSA_NAME_DEF_STMT (rhs2);
 	  if (is_gimple_assign (def_stmt)
 	      && gimple_assign_rhs_code (def_stmt) == NEGATE_EXPR
 	      && can_propagate_from (def_stmt))
@@ -2500,7 +2500,7 @@ associate_plusminus (gimple_stmt_iterator *gsi)
       if (TREE_CODE (rhs1) == SSA_NAME
 	  && code == PLUS_EXPR)
 	{
-	  gimple def_stmt = SSA_NAME_DEF_STMT (rhs1);
+	  gimple *def_stmt = SSA_NAME_DEF_STMT (rhs1);
 	  if (is_gimple_assign (def_stmt)
 	      && gimple_assign_rhs_code (def_stmt) == NEGATE_EXPR
 	      && can_propagate_from (def_stmt))
@@ -2545,7 +2545,7 @@ associate_plusminus (gimple_stmt_iterator *gsi)
 
   if (TREE_CODE (rhs1) == SSA_NAME)
     {
-      gimple def_stmt = SSA_NAME_DEF_STMT (rhs1);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (rhs1);
       if (is_gimple_assign (def_stmt) && can_propagate_from (def_stmt))
 	{
 	  enum tree_code def_code = gimple_assign_rhs_code (def_stmt);
@@ -2646,7 +2646,7 @@ associate_plusminus (gimple_stmt_iterator *gsi)
 		   && TREE_CODE (rhs2) == SSA_NAME)
 	    {
 	      /* (T)(ptr + adj) - (T)ptr -> (T)adj.  */
-	      gimple def_stmt2 = SSA_NAME_DEF_STMT (rhs2);
+	      gimple *def_stmt2 = SSA_NAME_DEF_STMT (rhs2);
 	      if (TREE_CODE (gimple_assign_rhs1 (def_stmt)) == SSA_NAME
 		  && is_gimple_assign (def_stmt2)
 		  && can_propagate_from (def_stmt2)
@@ -2696,7 +2696,7 @@ associate_plusminus (gimple_stmt_iterator *gsi)
 
   if (rhs2 && TREE_CODE (rhs2) == SSA_NAME)
     {
-      gimple def_stmt = SSA_NAME_DEF_STMT (rhs2);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (rhs2);
       if (is_gimple_assign (def_stmt) && can_propagate_from (def_stmt))
 	{
 	  enum tree_code def_code = gimple_assign_rhs_code (def_stmt);
@@ -2799,8 +2799,8 @@ out:
 static bool
 associate_pointerplus_align (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree ptr, rhs, algn;
 
   /* Pattern match
@@ -2851,8 +2851,8 @@ associate_pointerplus_align (gimple_stmt_iterator *gsi)
 static bool
 associate_pointerplus_diff (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree ptr1, rhs;
 
   /* Pattern match
@@ -2867,7 +2867,7 @@ associate_pointerplus_diff (gimple_stmt_iterator *gsi)
   rhs = gimple_assign_rhs2 (stmt);
   if (TREE_CODE (rhs) != SSA_NAME)
     return false;
-  gimple minus = SSA_NAME_DEF_STMT (rhs);
+  gimple *minus = SSA_NAME_DEF_STMT (rhs);
   /* Conditionally look through a sign-changing conversion.  */
   if (is_gimple_assign (minus)
       && CONVERT_EXPR_CODE_P (gimple_assign_rhs_code (minus))
@@ -2910,8 +2910,8 @@ associate_pointerplus_diff (gimple_stmt_iterator *gsi)
 static bool
 associate_pointerplus (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree ptr, off1, off2;
 
   if (associate_pointerplus_align (gsi)
@@ -2935,7 +2935,7 @@ associate_pointerplus (gimple_stmt_iterator *gsi)
     return false;
 
   tree off = make_ssa_name (TREE_TYPE (off1), NULL);
-  gimple ostmt = gimple_build_assign_with_ops (PLUS_EXPR, off, off1, off2);
+  gimple *ostmt = gimple_build_assign_with_ops (PLUS_EXPR, off, off1, off2);
   gsi_insert_before (gsi, ostmt, GSI_SAME_STMT);
 
   gimple_assign_set_rhs_with_ops (gsi, POINTER_PLUS_EXPR, ptr, off);
@@ -2951,8 +2951,8 @@ associate_pointerplus (gimple_stmt_iterator *gsi)
 static int
 combine_conversions (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree op0, lhs;
   enum tree_code code = gimple_assign_rhs_code (stmt);
   enum tree_code code2;
@@ -3146,7 +3146,7 @@ combine_conversions (gimple_stmt_iterator *gsi)
 static bool
 simplify_vce (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree type = TREE_TYPE (gimple_assign_lhs (stmt));
 
   /* Drop useless VIEW_CONVERT_EXPRs.  */
@@ -3161,7 +3161,7 @@ simplify_vce (gimple_stmt_iterator *gsi)
   if (TREE_CODE (op) != SSA_NAME)
     return false;
 
-  gimple def_stmt = SSA_NAME_DEF_STMT (op);
+  gimple *def_stmt = SSA_NAME_DEF_STMT (op);
   if (!is_gimple_assign (def_stmt))
     return false;
 
@@ -3210,8 +3210,8 @@ simplify_vce (gimple_stmt_iterator *gsi)
 static bool
 simplify_bitfield_ref (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree op, op0, op1, op2;
   tree elem_type;
   unsigned idx, n, size;
@@ -3323,8 +3323,8 @@ is_combined_permutation_identity (tree mask1, tree mask2)
 static int
 simplify_permutation (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree op0, op1, op2, op3, arg0, arg1;
   enum tree_code code;
   bool single_use_op0 = false;
@@ -3394,7 +3394,7 @@ simplify_permutation (gimple_stmt_iterator *gsi)
 	    {
 	      enum tree_code code2;
 
-	      gimple def_stmt2 = get_prop_source_stmt (op1, true, NULL);
+	      gimple *def_stmt2 = get_prop_source_stmt (op1, true, NULL);
 	      if (!def_stmt2 || !can_propagate_from (def_stmt2))
 		return 0;
 
@@ -3434,8 +3434,8 @@ simplify_permutation (gimple_stmt_iterator *gsi)
 static bool
 simplify_vector_constructor (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
-  gimple def_stmt;
+  gimple *stmt = gsi_stmt (*gsi);
+  gimple *def_stmt;
   tree op, op2, orig, type, elem_type;
   unsigned elem_size, nelts, i;
   enum tree_code code;
@@ -3525,14 +3525,14 @@ simplify_vector_constructor (gimple_stmt_iterator *gsi)
 static bool
 simplify_mult (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree arg1 = gimple_assign_rhs1 (stmt);
   tree arg2 = gimple_assign_rhs2 (stmt);
 
   if (TREE_CODE (arg1) != SSA_NAME)
     return false;
 
-  gimple def_stmt = SSA_NAME_DEF_STMT (arg1);
+  gimple *def_stmt = SSA_NAME_DEF_STMT (arg1);
   if (!is_gimple_assign (def_stmt))
     return false;
 
@@ -3615,7 +3615,7 @@ pass_forwprop::execute (function *fun)
 	 Note we update GSI within the loop as necessary.  */
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); )
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  tree lhs, rhs;
 	  enum tree_code code;
 
@@ -3702,7 +3702,7 @@ pass_forwprop::execute (function *fun)
 	 Note we update GSI within the loop as necessary.  */
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi);)
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  bool changed = false;
 
 	  /* Mark stmt as potentially needing revisiting.  */
diff --git a/gcc/tree-ssa-ifcombine.c b/gcc/tree-ssa-ifcombine.c
index fae389b..b3d2f7e 100644
--- a/gcc/tree-ssa-ifcombine.c
+++ b/gcc/tree-ssa-ifcombine.c
@@ -125,7 +125,7 @@ bb_no_side_effects_p (basic_block bb)
 
   for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple stmt = gsi_stmt (gsi);
+      gimple *stmt = gsi_stmt (gsi);
 
       if (gimple_has_side_effects (stmt)
 	  || gimple_vuse (stmt))
@@ -155,7 +155,7 @@ same_phi_args_p (basic_block bb1, basic_block bb2, basic_block dest)
   edge e1 = find_edge (bb1, dest);
   edge e2 = find_edge (bb2, dest);
   gimple_stmt_iterator gsi;
-  gimple phi;
+  gimple *phi;
 
   for (gsi = gsi_start_phis (dest); !gsi_end_p (gsi); gsi_next (&gsi))
     {
@@ -179,7 +179,7 @@ get_name_for_bit_test (tree candidate)
   if (TREE_CODE (candidate) == SSA_NAME
       && has_single_use (candidate))
     {
-      gimple def_stmt = SSA_NAME_DEF_STMT (candidate);
+      gimple *def_stmt = SSA_NAME_DEF_STMT (candidate);
       if (is_gimple_assign (def_stmt)
 	  && CONVERT_EXPR_CODE_P (gimple_assign_rhs_code (def_stmt)))
 	{
@@ -198,9 +198,9 @@ get_name_for_bit_test (tree candidate)
    Returns true if the pattern matched, false otherwise.  */
 
 static bool
-recognize_single_bit_test (gimple cond, tree *name, tree *bit, bool inv)
+recognize_single_bit_test (gimple *cond, tree *name, tree *bit, bool inv)
 {
-  gimple stmt;
+  gimple *stmt;
 
   /* Get at the definition of the result of the bit test.  */
   if (gimple_cond_code (cond) != (inv ? EQ_EXPR : NE_EXPR)
@@ -272,7 +272,7 @@ recognize_single_bit_test (gimple cond, tree *name, tree *bit, bool inv)
       && TREE_CODE (gimple_assign_rhs1 (stmt)) == SSA_NAME
       && TREE_CODE (gimple_assign_rhs2 (stmt)) == SSA_NAME)
     {
-      gimple tmp;
+      gimple *tmp;
 
       /* Both arguments of the BIT_AND_EXPR can be the single-bit
 	 specifying expression.  */
@@ -306,9 +306,9 @@ recognize_single_bit_test (gimple cond, tree *name, tree *bit, bool inv)
    Returns true if the pattern matched, false otherwise.  */
 
 static bool
-recognize_bits_test (gimple cond, tree *name, tree *bits, bool inv)
+recognize_bits_test (gimple *cond, tree *name, tree *bits, bool inv)
 {
-  gimple stmt;
+  gimple *stmt;
 
   /* Get at the definition of the result of the bit test.  */
   if (gimple_cond_code (cond) != (inv ? EQ_EXPR : NE_EXPR)
@@ -337,7 +337,7 @@ ifcombine_ifandif (basic_block inner_cond_bb, bool inner_inv,
 		   basic_block outer_cond_bb, bool outer_inv, bool result_inv)
 {
   gimple_stmt_iterator gsi;
-  gimple inner_cond, outer_cond;
+  gimple *inner_cond, *outer_cond;
   tree name1, name2, bit1, bit2, bits1, bits2;
 
   inner_cond = last_stmt (inner_cond_bb);
@@ -772,7 +772,7 @@ pass_tree_ifcombine::execute (function *fun)
   for (i = n_basic_blocks_for_fn (fun) - NUM_FIXED_BLOCKS - 1; i >= 0; i--)
     {
       basic_block bb = bbs[i];
-      gimple stmt = last_stmt (bb);
+      gimple *stmt = last_stmt (bb);
 
       if (stmt
 	  && gimple_code (stmt) == GIMPLE_COND)
diff --git a/gcc/tree-ssa-live.c b/gcc/tree-ssa-live.c
index 3cd3613..c046565 100644
--- a/gcc/tree-ssa-live.c
+++ b/gcc/tree-ssa-live.c
@@ -679,7 +679,7 @@ clear_unused_block_pointer (void)
       {
 	unsigned i;
 	tree b;
-	gimple stmt = gsi_stmt (gsi);
+	gimple *stmt = gsi_stmt (gsi);
 
 	if (!is_gimple_debug (stmt) && !gimple_clobber_p (stmt))
 	  continue;
@@ -802,7 +802,7 @@ remove_unused_locals (void)
       /* Walk the statements.  */
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  tree b = gimple_block (stmt);
 
 	  if (is_gimple_debug (stmt))
@@ -826,7 +826,7 @@ remove_unused_locals (void)
           use_operand_p arg_p;
           ssa_op_iter i;
 	  tree def;
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 
 	  if (virtual_operand_p (gimple_phi_result (phi)))
 	    continue;
@@ -863,7 +863,7 @@ remove_unused_locals (void)
 
 	for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi);)
 	  {
-	    gimple stmt = gsi_stmt (gsi);
+	    gimple *stmt = gsi_stmt (gsi);
 	    tree b = gimple_block (stmt);
 
 	    if (gimple_clobber_p (stmt))
@@ -1074,7 +1074,7 @@ static void
 set_var_live_on_entry (tree ssa_name, tree_live_info_p live)
 {
   int p;
-  gimple stmt;
+  gimple *stmt;
   use_operand_p use;
   basic_block def_bb = NULL;
   imm_use_iterator imm_iter;
@@ -1099,7 +1099,7 @@ set_var_live_on_entry (tree ssa_name, tree_live_info_p live)
      add it to the list of live on entry blocks.  */
   FOR_EACH_IMM_USE_FAST (use, imm_iter, ssa_name)
     {
-      gimple use_stmt = USE_STMT (use);
+      gimple *use_stmt = USE_STMT (use);
       basic_block add_block = NULL;
 
       if (gimple_code (use_stmt) == GIMPLE_PHI)
@@ -1162,7 +1162,7 @@ calculate_live_on_exit (tree_live_info_p liveinfo)
       /* Mark the PHI arguments which are live on exit to the pred block.  */
       for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 	  for (i = 0; i < gimple_phi_num_args (phi); i++)
 	    {
 	      tree t = PHI_ARG_DEF (phi, i);
@@ -1365,7 +1365,7 @@ verify_live_on_entry (tree_live_info_p live)
 {
   unsigned i;
   tree var;
-  gimple stmt;
+  gimple *stmt;
   basic_block bb;
   edge e;
   int num;
@@ -1440,7 +1440,7 @@ verify_live_on_entry (tree_live_info_p live)
 		     !gsi_end_p (gsi) && !ok;
 		     gsi_next (&gsi))
 		  {
-		    gimple phi = gsi_stmt (gsi);
+		    gimple *phi = gsi_stmt (gsi);
 		    for (z = 0; z < gimple_phi_num_args (phi); z++)
 		      if (var == gimple_phi_arg_def (phi, z))
 			{
diff --git a/gcc/tree-ssa-loop-ch.c b/gcc/tree-ssa-loop-ch.c
index e44f9de..da24162a 100644
--- a/gcc/tree-ssa-loop-ch.c
+++ b/gcc/tree-ssa-loop-ch.c
@@ -53,7 +53,7 @@ should_duplicate_loop_header_p (basic_block header, struct loop *loop,
 				int *limit)
 {
   gimple_stmt_iterator bsi;
-  gimple last;
+  gimple *last;
 
   /* Do not copy one block more than once (we do not really want to do
      loop peeling here).  */
@@ -111,7 +111,7 @@ should_duplicate_loop_header_p (basic_block header, struct loop *loop,
 static bool
 do_while_loop_p (struct loop *loop)
 {
-  gimple stmt = last_stmt (loop->latch);
+  gimple *stmt = last_stmt (loop->latch);
 
   /* If the latch of the loop is not empty, it is not a do-while loop.  */
   if (stmt
@@ -259,7 +259,7 @@ pass_ch::execute (function *fun)
 		   !gsi_end_p (bsi);
 		   gsi_next (&bsi))
 		{
-		  gimple stmt = gsi_stmt (bsi);
+		  gimple *stmt = gsi_stmt (bsi);
 		  if (gimple_code (stmt) == GIMPLE_COND)
 		    gimple_set_no_warning (stmt, true);
 		  else if (is_gimple_assign (stmt))
